#include "mainclass.h"

void MainClass::processNamFinished(QNetworkReply* reply){
    qDebug() << "reply"<<(uint64_t)reply<<"NAM finished:" << reply->errorString()<<" error:"<<reply->error();
}

MainClass::MainClass(QObject* parent):QObject(parent){
    i=0;
    time=new QTimer(this);
    time->setInterval(1000);
    connect(time,&QTimer::timeout,this,&MainClass::processRequest);
    nam=new QNetworkAccessManager(this);
    connect(nam,&QNetworkAccessManager::finished,this, &MainClass::processNamFinished);
    url=QUrl("https://api.lurity.com");
    time->start();
}

void MainClass::processRequest(){
    ++i;
    QNetworkReply *reply = nam->get(QNetworkRequest(url));
    QEventLoop loop2;
    if(reply->isOpen()){
        qDebug()<<"wait for reply: "<<(uint64_t)reply<<i<< reply->isFinished()<<reply->isOpen()<<reply->isRunning();
        QObject::connect(reply,SIGNAL(finished()),&loop2,SLOT(quit()));
        QObject::connect(reply,SIGNAL(error(QNetworkReply::NetworkError)),&loop2,SLOT(quit()));
        qDebug()<<"wait for reply:"<<(uint64_t)reply<<i<<" part 2"<< reply->isFinished()<<reply->isOpen()<<reply->isRunning();
        qDebug()<<"reply error status:"<<reply->error()<<reply->errorString();
        loop2.exec();
        if(reply->isFinished()){
            qDebug()<<"reply "<<(uint64_t)reply<<i<<" is ok"<<reply->error()<<reply->errorString()<<reply->isRunning();
        }else{
            qDebug() <<"reply "<<(uint64_t)reply<<i<<" not finished:"<<reply->error() << reply->errorString()<<reply->isRunning();
        }
    }else{
        qDebug()<<"reply "<<(uint64_t)reply<<i<<" is not open"<<reply->error()<<reply->errorString()<<"is finished:"<<reply->isFinished()<<reply->isRunning();
    }
    qDebug()<<"replay: "<<(uint64_t)reply<<i<<"============================ fully finished =========================";
    reply->deleteLater();
}
